// ===== Utils =======================================

var inipath = fb.FoobarPath + "WSH.ini";

function ansi(string)
{
    var res = string.replace(/\/|\\|\||:/g,'-');
    res = res.replace(/\*/g,'x');
    res = res.replace(/"/g,"''");
    res = res.replace(/\?|<|>/g,'_');
    
    return res;
}

String.prototype.trim = function() {
return this.replace(/^\s+|\s+$/g, '');
};

function backslash(path) {
	if (path.substr(path.length-1,1) == '\\') 
	{
		return path;
	}
	else 
	{
		return path + '\\';
	}
}

function pathClean(path) {
var arr = path.trim().replace(/^\s+|\s+$/m, '').split(/[\\\/]/);
var start = 0;

// Drive Letter?
if (arr[0].match(/\w:/)) {
start = 1;
}

for (var i = start; i < arr.length; ++i) {
var temp = arr[i].trim().replace(/[\/\\|:]/g, '-');
temp = temp.replace(/\*/g, 'x');
temp = temp.replace(/"/g, "''");
temp = temp.replace(/[?<>]/g, '_');
arr[i] = temp;
}

return arr.join('\\');
}

function decodeXMLEntites(text) {
    var doc = new ActiveXObject("htmlfile");
    doc.open();
    var div = doc.createElement("div");
    div.innerHTML = text;

    return div.innerHTML;
}

function RGB(r,g,b) {
	return (0xff000000|(r<<16)|(g<<8)|(b)); 
}

function translatePath(path, inorout) 
{
	var inpath = path.replace('/','\\');
	
    var foobpath = backslash(fb.FoobarPath.replace('/','\\'));
    var lastfmdatapath = backslash(utils.ReadINI(inipath, "LASTFM", "datapath", "").replace('/','\\'));
    if (inorout)
    {
        return backslash(path.replace("?foobarpath?", foobpath).replace("?lastfmdatapath?", lastfmdatapath));
    }
    else
    {
        return backslash(path.replace(foobpath,"?foobarpath?").replace(lastfmdatapath,"?lastfmdatapath?"));
    }
}

function titleFormatAnsi(path)
{
	var result = path;
	var variables = path.split("%");
	fb.trace("enter:"+result+",variablesnb:"+variables.length);
	for (var i in variables) 
	{
		if (i%2 == 1) //we catch variables between %%
		{
			fb.trace("variable:"+variables[i]);
			result = result.replace("%"+variables[i]+"%", ansi(fb.TitleFormat("%"+variables[i]+"%").Eval()));
		}
	}
	fb.trace("exit:"+result);
	return result;
}